package org.eclipse.datatools.enablement.ibm.db2.luw.model;


import org.eclipse.emf.ecore.EFactory;

/**
 * <!-- begin-user-doc -->
 * The <b>Factory</b> for the model.
 * It provides a create method for each non-abstract class of the model.
 * <!-- end-user-doc -->
 * @see org.eclipse.datatools.enablement.ibm.db2.luw.model.LUWPackage
 * @generated
 */
public interface LUWFactory extends EFactory {
	/**
	 * The singleton instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	LUWFactory eINSTANCE = org.eclipse.datatools.enablement.ibm.db2.luw.model.impl.LUWFactoryImpl.init();

	/**
	 * Returns a new object of class '<em>Partition Group</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Partition Group</em>'.
	 * @generated
	 */
	LUWPartitionGroup createLUWPartitionGroup();

	/**
	 * Returns a new object of class '<em>Table Space</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Table Space</em>'.
	 * @generated
	 */
	LUWTableSpace createLUWTableSpace();

	/**
	 * Returns a new object of class '<em>Database Partition</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Database Partition</em>'.
	 * @generated
	 */
	LUWDatabasePartition createLUWDatabasePartition();

	/**
	 * Returns a new object of class '<em>Database Container</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Database Container</em>'.
	 * @generated
	 */
	LUWDatabaseContainer createLUWDatabaseContainer();

	/**
	 * Returns a new object of class '<em>Admin Server</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Admin Server</em>'.
	 * @generated
	 */
	LUWAdminServer createLUWAdminServer();

	/**
	 * Returns a new object of class '<em>Buffer Pool</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Buffer Pool</em>'.
	 * @generated
	 */
	LUWBufferPool createLUWBufferPool();

	/**
	 * Returns a new object of class '<em>Table</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Table</em>'.
	 * @generated
	 */
	LUWTable createLUWTable();

	/**
	 * Returns a new object of class '<em>View</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>View</em>'.
	 * @generated
	 */
	LUWView createLUWView();

	/**
	 * Returns a new object of class '<em>Partition Key</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Partition Key</em>'.
	 * @generated
	 */
	LUWPartitionKey createLUWPartitionKey();

	/**
	 * Returns a new object of class '<em>Function Mapping</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Function Mapping</em>'.
	 * @generated
	 */
	LUWFunctionMapping createLUWFunctionMapping();

	/**
	 * Returns a new object of class '<em>Generic User Mapping</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Generic User Mapping</em>'.
	 * @generated
	 */
	LUWGenericUserMapping createLUWGenericUserMapping();

	/**
	 * Returns a new object of class '<em>Type Mapping</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Type Mapping</em>'.
	 * @generated
	 */
	LUWTypeMapping createLUWTypeMapping();

	/**
	 * Returns a new object of class '<em>User Mapping</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>User Mapping</em>'.
	 * @generated
	 */
	LUWUserMapping createLUWUserMapping();

	/**
	 * Returns a new object of class '<em>Option</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Option</em>'.
	 * @generated
	 */
	LUWOption createLUWOption();

	/**
	 * Returns a new object of class '<em>Database</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Database</em>'.
	 * @generated
	 */
	LUWDatabase createLUWDatabase();

	/**
	 * Returns a new object of class '<em>Column</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Column</em>'.
	 * @generated
	 */
	LUWColumn createLUWColumn();

	/**
	 * Returns a new object of class '<em>Generic Nickname</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Generic Nickname</em>'.
	 * @generated
	 */
	LUWGenericNickname createLUWGenericNickname();

	/**
	 * Returns a new object of class '<em>Generic Server</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Generic Server</em>'.
	 * @generated
	 */
	LUWGenericServer createLUWGenericServer();

	/**
	 * Returns a new object of class '<em>Materialized Query Table</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Materialized Query Table</em>'.
	 * @generated
	 */
	LUWMaterializedQueryTable createLUWMaterializedQueryTable();

	/**
	 * Returns a new object of class '<em>Generic Wrapper</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Generic Wrapper</em>'.
	 * @generated
	 */
	LUWGenericWrapper createLUWGenericWrapper();

	/**
	 * Returns a new object of class '<em>Relational Remote Server</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Relational Remote Server</em>'.
	 * @generated
	 */
	RelationalRemoteServer createRelationalRemoteServer();

	/**
	 * Returns a new object of class '<em>Relational Remote Data Set</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Relational Remote Data Set</em>'.
	 * @generated
	 */
	RelationalRemoteDataSet createRelationalRemoteDataSet();

	/**
	 * Returns a new object of class '<em>Remote Server</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Remote Server</em>'.
	 * @generated
	 */
	RemoteServer createRemoteServer();

	/**
	 * Returns a new object of class '<em>Remote Data Set</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Remote Data Set</em>'.
	 * @generated
	 */
	RemoteDataSet createRemoteDataSet();

	/**
	 * Returns a new object of class '<em>Index</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Index</em>'.
	 * @generated
	 */
	LUWIndex createLUWIndex();

	/**
	 * Returns a new object of class '<em>Attribute Definition</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Attribute Definition</em>'.
	 * @generated
	 */
	LUWAttributeDefinition createLUWAttributeDefinition();

	/**
	 * Returns a new object of class '<em>Federated Procedure</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Federated Procedure</em>'.
	 * @generated
	 */
	FederatedProcedure createFederatedProcedure();

	/**
	 * Returns a new object of class '<em>Federated Parameter</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Federated Parameter</em>'.
	 * @generated
	 */
	FederatedParameter createFederatedParameter();

	/**
	 * Returns a new object of class '<em>Partition Expression</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Partition Expression</em>'.
	 * @generated
	 */
	LUWPartitionExpression createLUWPartitionExpression();

	/**
	 * Returns a new object of class '<em>Partition Element</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Partition Element</em>'.
	 * @generated
	 */
	LUWPartitionElement createLUWPartitionElement();

	/**
	 * Returns a new object of class '<em>Data Partition</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Data Partition</em>'.
	 * @generated
	 */
	LUWDataPartition createLUWDataPartition();

	/**
	 * Returns a new object of class '<em>Data Partition Key</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Data Partition Key</em>'.
	 * @generated
	 */
	LUWDataPartitionKey createLUWDataPartitionKey();

	/**
	 * Returns a new object of class '<em>Database Package</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Database Package</em>'.
	 * @generated
	 */
	LUWDatabasePackage createLUWDatabasePackage();

	/**
	 * Returns a new object of class '<em>Module</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Module</em>'.
	 * @generated
	 */
	LUWModule createLUWModule();

	/**
	 * Returns a new object of class '<em>Module Function</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Module Function</em>'.
	 * @generated
	 */
	LUWModuleFunction createLUWModuleFunction();

	/**
	 * Returns a new object of class '<em>Module Procedure</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Module Procedure</em>'.
	 * @generated
	 */
	LUWModuleProcedure createLUWModuleProcedure();

	/**
	 * Returns a new object of class '<em>Module Condition</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Module Condition</em>'.
	 * @generated
	 */
	LUWModuleCondition createLUWModuleCondition();

	/**
	 * Returns a new object of class '<em>Global Variable</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Global Variable</em>'.
	 * @generated
	 */
	LUWGlobalVariable createLUWGlobalVariable();

	/**
	 * Returns a new object of class '<em>Module Row Data Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Module Row Data Type</em>'.
	 * @generated
	 */
	LUWModuleRowDataType createLUWModuleRowDataType();

	/**
	 * Returns a new object of class '<em>Module Array Data Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Module Array Data Type</em>'.
	 * @generated
	 */
	LUWModuleArrayDataType createLUWModuleArrayDataType();

	/**
	 * Returns a new object of class '<em>Module Distinct Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Module Distinct Type</em>'.
	 * @generated
	 */
	LUWModuleDistinctType createLUWModuleDistinctType();

	/**
	 * Returns a new object of class '<em>Module Global Variable</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Module Global Variable</em>'.
	 * @generated
	 */
	LUWModuleGlobalVariable createLUWModuleGlobalVariable();

	/**
	 * Returns a new object of class '<em>Array Data Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Array Data Type</em>'.
	 * @generated
	 */
	LUWArrayDataType createLUWArrayDataType();

	/**
	 * Returns a new object of class '<em>Row Data Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Row Data Type</em>'.
	 * @generated
	 */
	LUWRowDataType createLUWRowDataType();

	/**
	 * Returns a new object of class '<em>PLSQL Package</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>PLSQL Package</em>'.
	 * @generated
	 */
	PLSQLPackage createPLSQLPackage();

	/**
	 * Returns a new object of class '<em>PLSQL Package Body</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>PLSQL Package Body</em>'.
	 * @generated
	 */
	PLSQLPackageBody createPLSQLPackageBody();

	/**
	 * Returns a new object of class '<em>Cursor Data Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Cursor Data Type</em>'.
	 * @generated
	 */
	LUWCursorDataType createLUWCursorDataType();

	/**
	 * Returns a new object of class '<em>Module Cursor Data Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Module Cursor Data Type</em>'.
	 * @generated
	 */
	LUWModuleCursorDataType createLUWModuleCursorDataType();

	/**
	 * Returns a new object of class '<em>Buffer Pool Size Exception</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Buffer Pool Size Exception</em>'.
	 * @generated
	 */
	LUWBufferPoolSizeException createLUWBufferPoolSizeException();

	/**
	 * Returns a new object of class '<em>Member</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Member</em>'.
	 * @generated
	 */
	LUWMember createLUWMember();

	/**
	 * Returns a new object of class '<em>Security Policy</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Security Policy</em>'.
	 * @generated
	 */
	LUWSecurityPolicy createLUWSecurityPolicy();

	/**
	 * Returns a new object of class '<em>Security Label Component</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Security Label Component</em>'.
	 * @generated
	 */
	LUWSecurityLabelComponent createLUWSecurityLabelComponent();

	/**
	 * Returns a new object of class '<em>Security Label</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Security Label</em>'.
	 * @generated
	 */
	LUWSecurityLabel createLUWSecurityLabel();

	/**
	 * Returns a new object of class '<em>Security Label Component Element</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Security Label Component Element</em>'.
	 * @generated
	 */
	LUWSecurityLabelComponentElement createLUWSecurityLabelComponentElement();

	/**
	 * Returns a new object of class '<em>Storage Group</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Storage Group</em>'.
	 * @generated
	 */
	LUWStorageGroup createLUWStorageGroup();

	/**
	 * Returns a new object of class '<em>Temporary Storage Table</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Temporary Storage Table</em>'.
	 * @generated
	 */
	LUWTemporaryStorageTable createLUWTemporaryStorageTable();

	/**
	 * Returns a new object of class '<em>Temporary Table</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Temporary Table</em>'.
	 * @generated
	 */
	LUWTemporaryTable createLUWTemporaryTable();

	/**
	 * Returns a new object of class '<em>Array Index Element Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Array Index Element Type</em>'.
	 * @generated
	 */
	ArrayIndexElementType createArrayIndexElementType();

	/**
	 * Returns a new object of class '<em>Partition Every Clause Element</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Partition Every Clause Element</em>'.
	 * @generated
	 */
	LUWPartitionEveryClauseElement createLUWPartitionEveryClauseElement();

	/**
	 * Returns the package supported by this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the package supported by this factory.
	 * @generated
	 */
	LUWPackage getLUWPackage();

} //LUWFactory
